hdu-5314 Happy King

题意:

给出一颗n个结点的树,点上有权值;

求点对(x,y)满足x!=y且x到y的路径上最大值与最小值的差<=D;

n<=100000,多组数据,所有数据n的总和<=500000;

题解:

来填一填当年挖下的坑;

这个数据范围真是恶意。。直接说五组数据不好吗!

考虑这题怎么做,在这场考试那天的前一天,我学习了树分治算法;

然后他就出了,然后我就写了,然后我就写不出来了;

当年的我实在naive;

我翻出了当时交上去的代码,改了好久好久。。

首先这道题的思路比较容易,最直观的就是树的点分治嘛;

分治之后统计答案,首先搜出从当前根出发到所有点的最大权值与最小权值;

然后为了统计数量,我们先按最大权值从小到大排个序;

那么如果就让这个最大权值为路上的最大权值,那另一个端点一定排序在它前面;

所以一边遍历一边将点的最小值插入树状数组里;

每次查询[0,点到根路径上最大值-D]这个区间的值就好了;

复杂度O(nlog^2n),别人还有更加优越的log做法;

嘴巴很好A对吧,然而我当时真是没救;

我居然每次求出重心之后,没有用重心去分治!

这两个代码的区别就差一个字母啊!然后复杂度不对调了我半天。。

代码:

#pragma comment(linker, "/STACK:102400000,102400000")
#include<ctype.h>
#include<stdio.h>
#include<string.h>
#include<algorithm>
#define N 100100
using namespace std;
typedef long long ll;
struct pr
{
	int ma,mi;
	friend bool operator <(pr a,pr b)
	{
		return a.ma<b.ma;
	}
}popo[N];
int to[N<<1],nex[N<<1],head[N],val[N];
int size[N],dis[N],len;
int D,tot,mi,G,bk,cnt;
ll ans;
int sum[N];
bool ban[N];
void init()
{
    memset(head,0,sizeof(head));
    memset(ban,0,sizeof(ban));
    tot=0,ans=0;
}
inline char getc()
{
	static char buf[1<<15],*S,*T;
	if(S==T)
	{
		T=(S=buf)+fread(buf,1,1<<15,stdin);
		if(S==T)	return EOF;
	}
	return *S++;
}
inline int read()
{
	static char ch;
	static int D;
	while(!isdigit(ch=getc()));
	for(D=ch-'0';isdigit(ch=getc());)
		D=D*10+(ch-'0');
	return D;
}
inline int lowbit(int x)
{
    return x&(-x);
}
inline int lb(int x)
{
	int l=1,r=len,mid;
	while(l<=r)
	{
		mid=l+r>>1;
		if(dis[mid]<x)
			l=mid+1;
		else
			r=mid-1;
	}
	return l;
}
void update(int x,int val)
{
    while(x<=len)
    {
        sum[x]+=val;
        x+=lowbit(x);
    }
}
int query(int x)
{
    if(x<=0)    return 0;
    int ret=0;
    while(x)
    {
        ret+=sum[x];
        x-=lowbit(x);
    }
    return ret;
}
void add(int x,int y)
{
    to[++tot]=y;
    nex[tot]=head[x];
    head[x]=tot;
}
void get_G(int x,int pre)
{
    size[x]=1;
    int i,y,temp=0;
    for(i=head[x];i;i=nex[i])
    {
        if(!ban[y=to[i]]&&y!=pre)
        {
            get_G(y,x);
            size[x]+=size[y];
            temp=max(temp,size[y]);
        }
    }
    temp=max(temp,bk-size[x]);
    if(temp<mi)
        mi=temp,G=x;
}
void dfs(int x,int pre,int ma,int mi)
{
	if(ma-mi>D)	return ;
    ma=max(ma,val[x]);
    mi=min(mi,val[x]);
    static pr p;
    p.ma=ma,p.mi=mi;
    popo[++cnt]=p;
    int i,y;
    for(i=head[x];i;i=nex[i])
    {
        if(!ban[y=to[i]]&&y!=pre)
        {
            dfs(y,x,ma,mi);
        }
    }
}
ll calc(int x)
{
	static pr p;
	p.ma=p.mi=val[x];
    popo[cnt=1]=p;
    int i,j,y,last;
    ll ret=0;
    for(j=head[x];j;j=nex[j])
    {
        if(!ban[y=to[j]])
        {
            last=cnt;
            dfs(y,x,val[x],val[x]);
            sort(popo+last+1,popo+cnt+1);
            for(i=last+1;i<=cnt;i++)
            {
				if(popo[i].ma-popo[i].mi<=D)
                ret+=i-last-1-query(lb(popo[i].ma-D)-1);
                update(lb(popo[i].mi),1);
            }
            for(i=last+1;i<=cnt;i++)
                update(lb(popo[i].mi),-1);
        }
    }
    ret=-ret;
    sort(popo+1,popo+cnt+1);
    for(i=1;i<=cnt;i++)
    {
    	if(popo[i].ma-popo[i].mi<=D)
        ret+=i-1-query(lb(popo[i].ma-D)-1);
        update(lb(popo[i].mi),1);
    }
    for(i=1;i<=cnt;i++)
        update(lb(popo[i].mi),-1);
    return ret;
}
void slove(int x)
{
    ban[x]=1;
    if(bk==1)	{ban[x]=0;return ;}
    int i,y;
    for(i=head[x];i;i=nex[i])
    {
        if(!ban[y=to[i]])
        {
            bk=size[y];
            mi=0x3f3f3f3f;
            get_G(y,x);
            slove(G);
        }
    }
	ans+=calc(x);
	ban[x]=0;
}
int main()
{
//	freopen("tt.in","r",stdin);
    int c,T,n,m,i,j,k,x,y;
    T=read();
    for(c=1;c<=T;c++)
    {
        init();
        n=read(),D=read();
        for(i=1;i<=n;i++)
        {
        	val[i]=read();
            dis[i]=val[i];
        }
        sort(dis+1,dis+n+1);
        len=unique(dis+1,dis+n+1)-dis-1;
        for(i=1;i<n;i++)
        {
            x=read(),y=read();
            add(x,y),add(y,x);
        }
        bk=n;
        mi=0x3f3f3f3f;
        get_G(1,0);
        slove(G);
        printf("%lld\n",ans<<1);
    }
    return 0;
}
时间: 2024-11-13 10:44:50

hdu-5314 Happy King的相关文章

hdu 5314 Happy King 树点分冶 树状数组

Happy King Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 434    Accepted Submission(s): 79 Problem Description There are n cities and n?1 roads in Byteland, and they form a tree. The citie

hdu 5314 动态树

Happy King Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)Total Submission(s): 821    Accepted Submission(s): 179 Problem Description There are n cities and n−1 roads in Byteland, and they form a tree. The citie

hdu 3861 The King’s Problem (强连通+最小路径覆盖)

The King's Problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1637    Accepted Submission(s): 600 Problem Description In the Kingdom of Silence, the king has a new problem. There are N cit

HDU 3861 The King’s Problem(强连通+二分图最小路径覆盖)

HDU 3861 The King's Problem 题目链接 题意:给定一个有向图,求最少划分成几个部分满足下面条件 互相可达的点必须分到一个集合 一个对点(u, v)必须至少有u可达v或者v可达u 一个点只能分到一个集合 思路:先强连通缩点,然后二分图匹配求最小路径覆盖 代码: #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #include <

ZOJ 2334 HDU 1512 Monkey King

题意: 猴子们打架  认识的猴子不会打架  两只猴子打完以后就认识了  A认识B B认识C A也认识C  每次打架由两伙猴子进行  分别选出自己的最高战斗力  在战斗之后两只猴子战斗力减半  给出m次打架  输出打架后这一伙猴子里的最强战斗力 思路: 判断两只猴子是不是一伙的  用到并查集 快速找出一伙猴子中的最强战斗力用到堆  但打完架两伙猴子合并时堆需要nlogn复杂度  因此用左偏树代替堆 代码: #include<cstdio> #include<cstring> #inc

HDU 3861 The King&#39;s Problem(强连通分量缩点+最小路径覆盖)

http://acm.hdu.edu.cn/showproblem.php?pid=3861 题意: 国王要对n个城市进行规划,将这些城市分成若干个城市,强连通的城市必须处于一个州,另外一个州内的任意两个城市u,v,有从u到v的路径或从v到u的路径.求最少可以分成几个州. 思路: 这道题目挺好. 首先,强连通分量进行缩点,重新建图. 新建的图就是一个DAG图,接下来就转换成了最小路径覆盖问题. 最小路径覆盖就是用尽量少的不相交的简单路径覆盖DAG的所有顶点.每个顶点只属于一条路径,单个顶点也可以

HDU 4489 The King&#39;s Ups and Downs

题目链接 问的是n个不一样的数,大小交替,或者小大交替的种类数量. n个数,想象成[1,n]的自然数即可. 我们假设大小交替得到的长度为i的排列数为dp1[i],小大交替得到的长度为i的排列数为dp2[i],因为是对称的,其实应该有dp1=dp2,我们要计算的总和sum=dp1+dp2. 我们从小到大考虑各个数,一个个插入队列,考虑到第i个数,称为ai,ai比前i-1个数都大,可以插入的位置j∈[1,i]. ai插入的位置为j时,前面的i-1个人比自己小,选择出来排列的情况有C(i-1,j-1)

HDU 3861.The King’s Problem 强联通分量+最小路径覆盖

The King’s Problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 2947    Accepted Submission(s): 1049 Problem Description In the Kingdom of Silence, the king has a new problem. There are N cit

HDU——T The King’s Problem

http://acm.hdu.edu.cn/showproblem.php?pid=3861 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3254    Accepted Submission(s): 1151 Problem Description In the Kingdom of Silence, the king has a

HDU 3861 The King’s Problem (强连通+二分匹配)

题目地址:HDU 3861 这题虽然是两个算法结合起来的.但是感觉挺没意思的..结合的一点也不自然,,硬生生的揉在了一块...(出题者不要喷我QAQ.) 不过这题让我发现了我的二分匹配已经好长时间没用过了..都快忘了..正好在省赛之前又复习了一下. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm>